<?php
// No direct file access
if ( ! defined( 'ABSPATH' ) ) exit; 

/**
 * All Settings
 */
if ( !function_exists( 'beebogo_settings' ) ) {
	function beebogo_settings(){
		if ( is_admin() ) {

			$beebogo_settings = get_option('beebogo_settings');
			$enabled 			= ( !empty($beebogo_settings) ) ? $beebogo_settings['enabled'] : 'off' ;
			$select_category 	= ( !empty($beebogo_settings['rules']['category']) ) ? $beebogo_settings['rules']['category'] : '';
			$select_products 	= ( !empty($beebogo_settings['rules']['products']) ) ? $beebogo_settings['rules']['products'] : array();
			?>
	        <div class="clear"></div>
	        <form method="post" action="">
	            <div class="bee-bogo-wrapper">
	                <h2><?php echo esc_html__('Bee BOGO for WooCommerce', 'bee_bogo'); ?></h2>
	            </div>
	            <div class="clear"></div>
	            <div class="bee-bogo-wrapper">
	            	<div class="bee-bogo-panel">
	                    <div class="section">

	                    	<div class="form-control section-header">
	                    		<h3 class="section heading"><?php echo esc_html__('Set Rules', 'bee_bogo'); ?></h3>
	                    	</div>

	                        <div class="form-control">
	                            <label class="explain" for="enable_bee_bogo"><?php echo esc_html__('Enable Bee BOGO', 'bee_bogo'); ?></label>
	                            <span class="form-field">
	                            	<input type="checkbox" name="enable_bee_bogo" id="enable_bee_bogo" <?php echo ($enabled == 'on') ? 'checked' : '' ?>>
	                            </span>
	                        </div>

	                        <div class="form-control">
	                            <table class="bogo-settings">
	                            	<thead>
	                            		<tr>
	                            			<th><?php echo esc_html__('Offer Name', 'bee_bogo'); ?></th>
	                            			<th><?php echo esc_html__('Select Category', 'bee_bogo'); ?></th>
	                            			<th><?php echo esc_html__('Select Products', 'bee_bogo'); ?></th>
	                            			<th><?php echo esc_html__('Offer for', 'bee_bogo'); ?></th>
	                            			<th><?php echo esc_html__('Offered Products', 'bee_bogo'); ?></th>
	                            			<th></th>
	                            		</tr>
	                            	</thead>
	                            	<tbody>
	                            		<tr class="cloned">
	                            			<td>
	                            				<select name="offer_name[0]"  class="select-offer">
	                            					<option><?php echo __('Select an Offer Title') ?></option>
	                            					<option value="1_1" <?php echo ($enabled == 'on') ? 'selected' : '' ?>><?php echo __('Buy One Get One Free') ?></option>
	                            					<option value="1_1" disabled><?php echo esc_html__('Buy One Get One Free (Pro)') ?></option>
	                            					<option value="1_1" disabled><?php echo esc_html__('Buy Two Get One Free (Pro)') ?></option>
	                            					<option value="1_1" disabled><?php echo esc_html__('Buy Three Get One Free (Pro)') ?></option>
	                            					<option value="1_1" disabled><?php echo esc_html__('Get 50% off on Second item (Pro)') ?></option>
	                            				</select>
	                            			</td>
	                            			<td>
	                            				<select name="select_category[0]" class="select-category">
	                            					<option><?php echo __('Select Category') ?></option>
		                            				<?php
		                            				$product_categories = get_terms( array(
														    'taxonomy'   => 'product_cat',
														    'hide_empty' => true,
														) );
		                            				foreach ( $product_categories as $category ) {
		                            					if ( $category->term_id == $select_category ) {
		                            						echo '<option value="'. $category->term_id .'" selected>'. $category->name .'</option>';
		                            					}
		                            					else {
		                            						echo '<option value="'. $category->term_id .'">'. $category->name .'</option>';
		                            					}
													}
		                            				?>
	                            				</select>
	                            			</td>
	                            			<td>
	                            				<select name="select_products[0][]" class="select-products"  multiple="multiple">
	                            					<option value="0"><?php echo __('Select Products') ?></option>
	                            					<?php
	                            					$products = get_posts( array(
														    'post_type'   => 'product',
														    'numberposts' => -1,
														) );

	                            					foreach ( $products as $product ) {
	                            						if ( in_array( $product->ID, $select_products ) ) {
		                            						echo '<option value="'. $product->ID .'" selected>'. $product->post_title .'</option>';
		                            					}
		                            					else {
	                            							echo '<option value="'. $product->ID .'">'. $product->post_title .'</option>';
	                            						}
													}
													?>
												</select>
											</td>
	                            			<td>
	                            				<select name="offer_for[0]" class="select-offerfor">
	                            					<option value="same"><?php echo esc_html__('Same Products', 'bee_bogo') ?></option>
	                            					<option value="same" disabled><?php echo esc_html__('Different Products', 'bee_bogo') ?> (Pro)</option>
	                            				</select>
	                            			</td>
	                            			<td>
	                            				<input type="text" name="offer_prodcut" placeholder="Offer Products (Pro)" disabled>
	                            			</td>
	                            			<td><span class="dashicons dashicons-remove remove-row pre-feature" name="remove[0]"></span></td>
	                            		</tr>
	                            	</tbody>
	                            	<tfoot>
	                            		<tr>
	                            			<th colspan="6">
	                            				<button id="add_row" class="pre-feature"><?php echo esc_html__('Add Row', 'bee_bogo'); ?> (Pro)</button>
	                            			</th>
	                            		</tr>
	                            	</tfoot>
	                            </table>
	                            <div class="loader">
	                            	<img src="<?php echo BeeBOGOF_URL .'assets/images/loader.gif' ?>">
	                            </div>
	                        </div>

	                        <div class="form-control section-upgrade">
	                        	<div class="upgrade-pro">
					    			<p>Upgrade to the Pro version for additional features and benefits. <a href="https://www.beeplugin.com/bogo-deals-woocommerce-discount/" target="_blank">Upgrade Now</a></p>
					    		</div>
	                        </div>

	                        <div class="form-control section-footer">
	                        	<?php wp_nonce_field('beebogo_submit', 'beebogo_nonce'); ?>
	                        	<input type="submit" name="submit_bogo" value="Save" class="submit-form">
	                        </div>
	                    </div>
	                </div>
	            </div>
	        </form>
	        <?php
		}
	}
}

/**
 * Add amin menu
 */
function beebogo_pro_admin_menu() {

	$menu_url = menu_page_url( 'bee-plugins', false );

	if ( ! $menu_url ) {
		add_menu_page(
            'BeePlugins',
            'BeePlugins',
            'manage_options',
            'bee-plugins',
            'beebogo_settings',
            BeeBOGOF_URL .'assets/images/bee-icon.png',
            50
        );
        add_submenu_page(
            'bee-plugins',
            'BeePlugins Addons',
            'Addons',
            'manage_options',
            'bee-plugins-addons',
            'beep_cus_dis_addons',
        );
    }
    else {
    	add_submenu_page(
	        'bee-plugins',
	        'Bee BOGO for WooCommerce',
	        'Bee BOGO',
	        'manage_options',
	        'bee-bogo-settings',
	        'beebogo_settings',
	    );
    }
}
add_action('admin_menu', 'beebogo_pro_admin_menu');

/**
 * get all products by category
 */
function beebogo_get_prodcuts_by_cat() {

	// Verify nonce
	if ( ! isset( $_POST['nonce'] ) || ! wp_verify_nonce( sanitize_text_field( wp_unslash ( $_POST['nonce'] ) ) , 'beebogo' ) ) {
        wp_send_json_error('Invalid nonce');
    }

    $term_id = sanitize_text_field( $_POST['cat'] );

    if ( !empty($term_id) ) {

    	$products = get_posts(array(
		    'post_type' => 'product',
		    'posts_per_page' => -1,
		    'tax_query' => array(
		        array(
		            'taxonomy' => 'product_cat',
		            'field' => 'term_id',
		            'terms' => $term_id,
		        ),
		    ),
		));

		$html 	= '';

		foreach ($products as $product) {
			$html .= '<option value="' . $product->ID . '">' . $product->post_title . '</option>';
		}

        wp_send_json_success($html);
    }
    else {
    	wp_send_json_error('No product found');
    }
}
add_action('wp_ajax_beebogo_get_prodcuts_by_cat', 'beebogo_get_prodcuts_by_cat');

/**
 * Save all settings
 */

function beebogo_save_settings() {

	if ($_SERVER['REQUEST_METHOD'] === 'POST' && isset($_POST['beebogo_nonce'])) {

		if (!isset($_POST['beebogo_nonce']) || !wp_verify_nonce($_POST['beebogo_nonce'], 'beebogo_submit')) {
	        die('Security check failed!');
	    }

	    $enable_bee_bogo = (isset($_POST['enable_bee_bogo'])) ? sanitize_text_field( $_POST['enable_bee_bogo'] ) : 'off' ;
		$select_category = (isset($_POST['select_category'])) ? sanitize_text_field( $_POST['select_category'][0]) : '' ;
		$select_products = (isset($_POST['select_products'])) ? array_map('sanitize_text_field', $_POST['select_products'][0]) : '' ;

		$beebogo_settings = array(
			'enabled' => $enable_bee_bogo,
			'rules' => array(
				'category' => $select_category,
				'products' => $select_products,
			),
		);

		if (!current_user_can('manage_options')) {
	        die('You do not have permission to submit this form.');
	    }

	    update_option('beebogo_settings', $beebogo_settings);
	}
}
add_action( 'admin_init', 'beebogo_save_settings' );