<?php
// No direct file access
if ( ! defined( 'ABSPATH' ) ) exit; 

if ( !function_exists( 'beep_cus_dis_addons' ) ) {

    function beep_cus_dis_addons() {
        
        $store_url = 'https://www.beeplugin.com';
		$consumer_key = 'ck_b0fd2717db389ef5c564315cd2922ff3cb9affc9';
		$consumer_secret = 'cs_b344d6e55124c2fce8d20fc411c06a5510f771a1';
		$endpoint = $store_url . '/wp-json/wc/v3/products?per_page=30';

		$credentials = base64_encode($consumer_key . ':' . $consumer_secret);
		$addons 	= array();

		$headers = array(
		    'Content-Type' => 'application/json',
		    'Authorization' => 'Basic ' . $credentials,
		);

		$args = array(
		    'headers' => $headers,
		);

		$response = wp_remote_get($endpoint, $args);

		// Check for errors
		if (is_wp_error($response)) {
		    echo "Error: " . $response->get_error_message();
		} else {
		    $http_code = wp_remote_retrieve_response_code($response);

		    // Check the HTTP status code and handle the response accordingly
		    if ($http_code == 200) {
		        // Successful request, handle $body data
		        $products 	= wp_remote_retrieve_body($response);
		        $products   = json_decode($products);
			    $addon 		= array();
			    

			    foreach ($products as $product) {
			    	$addon['product_id'] 		= $product->id;
			    	$addon['name'] 				= $product->name;
			    	$addon['parmalink'] 		= $product->permalink;
			    	$addon['price'] 			= $product->price;
			    	$product_image 				= $product->images;
			    	$addon['thubnail'] 			= $product_image[0]->src;
			    	$addon['short_description'] = $product->short_description;
			    	array_push($addons, $addon);
			    }
		    } else {
		        // Handle error
		        echo "Error: HTTP Status Code " . $http_code . ", Response: " . wp_remote_retrieve_body($response);
		    }
		}


		?>
		<div class="clear"></div>
		<div class="bee-addons-wrapper">
			<h2><?php echo esc_html__('Welcome to BeePlugins Addons', 'bee_bogo'); ?></h2>
			<p><?php echo esc_html__('Explore a new level of functionality and convenience with our carefully crafted Addons.', 'bee_bogo'); ?></p>
		</div>

		<div class="clear"></div>
		<div class="bee-addons-wrapper">
			<div class="bee-addons-panel addon-card-wrap">
				<ul class="cards">
					<?php
					if ( !empty($addons) ) {
						foreach ($addons as $key => $addon) {
							?>
							<li class="card">
						      <div class="card__img">
						        <div class="img__cover">
						          <img src="<?php echo $addon['thubnail']; ?>" alt="" />
						        </div>
						        <div class="img__profile">
						          <span class="addon-price">$<?php echo $addon['price']; ?></span>
						        </div>
						      </div>
						      <div class="[ card__text ] [ flow ]">
						        <h2>
						          <a href="<?php echo $addon['parmalink']; ?>"><?php echo $addon['name']; ?></a>
						        </h2>
						        <div class="meta">
						          <p class="meta__info">
						          	<?php echo $addon['short_description']; ?>
						          </p>
						        </div>
						      </div>
						    </li>
							<?php
						}
					}
					?>
				</ul>
			</div>
		</div>
		<?php
    }
}